package edu.harvard.mgh.purcell.gplink.data;

/**
 * This contains all the key words used in gPLINK. Most
 * of these are static strings.
 * @author Kathe Todd-Brown
 *
 */
public class KeyWords {


	///////////////////////////////////////////////////////
	//////////////////// Static variables /////////////////
	///////////////////////////////////////////////////////

	/* ************************
	 * Default values
	 * ************************
	 */
	
	/** 
	 * default editor command for non-window & non-mac os
	 * */
	static String LINUX_DEFAULT_EDITOR = "emacs";
	
	/** 
	 * default editor command for window os 
	 */
	static String WINDOW_DEFAULT_EDITOR = "write";
	
	/** 
	 * default editor command for mac os 
	 */
	static String MAC_DEFAULT_EDITOR = "open -a /Applications/TextEdit.app";
	
	/** 
	 * base of locked code in lock file that appear in LOCK_FILE
	 */
	static String LOCKED_BASE = "True";
	
	/** 
	 * a unique lock code for this instance of 
	 * Project that appear in LOCK_FILE
	 */
	static String LOCKED_CODE = LOCKED_BASE 
			+ (int)(Math.random()*100000000);
	
	/** 
	 * unlocked code that appear in LOCK_FILE
	 */
	  static String UNLOCKED_CODE = "False";
	

	
	/* *****************************
	 * names of configationfiles
	 * *****************************
	 */
	
	/** 
	 * name of the meta file 
	 */
	public static String LOG_FILE = ".metafile_gplink";
	
	/** 
	 * name of lock file 
	 */
	public static String LOCK_FILE = ".lock_gplink";
	
	/** 
	 * name of file that stores remote parameters. In this case
	 * it's .gplink_remote
	*/
	public static String REMOTE_FILE = ".gplink_remote";
	
	/**
	 * extention for the status of a given operation file. In
	 * this case it's .gplink
	 */
	public static String OP_STATUS_EXT = ".gplink";
	
	/**
	 * configuration file for the global settings. In this case
	 * it's .gplink_config
	 */
	public static String GLOBAL_CONFIG_FILE = ".gplink_config";
	
	/** 
	 * root name of the operations summary file 
	 * (appended with time stamp and .html) 
	 */
	public static String OP_SUM_FILE = "logfile-";
	
	/* *******************************************
	 * keys for config files, and project document
	 * *******************************************
	 */
	
	/** 
	 * key name of file key in project/metafile
	 */
	  static String FILE_KEY = "entity";
	
	/**
	 * key name of file annotation node
	 */
	  static String FOLDER_KEY = "file_notes";
	
	/**
	 * key name of the operations in project 
	 */
	  static String OP_KEY = "operation";
	
	/** 
	 * key name of the command line attribute key of the operation 
	 */ 
	  static String CLINE_KEY = "cline";
	
	/**
	 * key name of the plink path attribute key in the project that
	 * holds the location of plink exicutable
	 */
	public static String PLINK_PATH_KEY = "plink_path";
	
	/**
	 * key for the haploview path
	 */
	public static String HAPLOVIEW_PATH_KEY = "haploview_path";
	
	/**
	 * key for the haploview appendment
	 */
	public static String HAPLOVIEW_APPEND = "haploview_append";
	
	/**
	 * key for the editor
	 */
	public static String USER_EDITOR_KEY = "editor";
	
	/**
	 * key for prefix of plink command user controlled
	 */
	public static String PLINK_PREFIX = "plink_prefix";
	
	/**
	 * name of the number of operations ever created in
	 * attribute key of project
	 */ 
	 // static String EOP_KEY = "ever_ops";
	
	/**
	 * name of the xml format version being used in project
	 */
	  static String VS_KEY = "version";
	
	/**
	 * name of the element containing the input files for an operation
	 */
	public static String INFILE_KEY = "input";
	
	/**
	 * name of the number of files in input/output attribute key
	 */
	 // static String NUM_FILE_KEY = "num_file";
	
	/**
	 * name of the element containing the output files for an operation
	 */
	public static String OUTFILE_KEY = "output";
	
	/**
	 * Key for the browse only flag.
	 */
	public static String BROWSE_KEY = "browse";
	
	/**
	 * key for the most recent project opened for the gobal config
	 * file
	 */
	public static String PROJECT1 = "project1";
	
	/**
	 * key for the 2nd most recent project opened for the gobal config
	 * file
	 */
	public static String PROJECT2 = "project2";
	
	/**
	 * key for the 3nd most recent project opened for the gobal config
	 * file
	 */
	public static String PROJECT3 = "project3";
	
	/**
	 * key for the 4nd most recent project opened for the gobal config
	 * file
	 */
	public static String PROJECT4 = "project4";
	
	/**
	 * key for the home directory
	 */
	protected static String HOME_KEY = "home";
	
	/**
	 * key for name attribute in project, operation and file
	 */
	protected static String NAME_KEY = "name";
	
	/**
	 * key for short file name
	 */
	protected static String SHORT_NAME_KEY = "short_name";
	
	/**
	 * String to flag a false boolean
	 */
	public static String FALSE = "false";
	
	/**
	 * String to flag a true boolean
	 */
	public static String TRUE = "true";
	

	/* ***********************************
	 * keys for remote configureation file
	 * ***********************************
	 */
	/**
	 * key for port number
	 */
	public static String PORT_KEY = "port";
	
	/**
	 * key for the user's name in the remote config file
	 */
	public static String USER_KEY = "user";
	
	/**
	 * key for the host's name in the remote config file
	 */
	public static String HOST_KEY = "host";
	
	/**
	 * key for the remote project folder in the remote config file
	 */
	public static String REMOTE_PROJECT_KEY = "folder";
}
