package edu.harvard.mgh.purcell.gplink.mainGUI;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;

import edu.harvard.mgh.purcell.gplink.base_form.GeneralUtil;
import edu.harvard.mgh.purcell.gplink.data.Project;

@SuppressWarnings("serial")
public class LinkNewFileDialog extends JDialog {

	Project data;
	
	String opName;
	JTextField addFile;
	JRadioButton infile, outfile;
	JButton ok, quit;
	JPanel filePane, inOutPane, buttonPane;
	
	ActionListener process = new ActionListener(){

		@SuppressWarnings("static-access")
		public void actionPerformed(ActionEvent arg0) {
			String fileType;
			
			if(infile.isSelected())
				fileType = data.INFILE_KEY;
			else
				fileType = data.OUTFILE_KEY;
			
			if(!addFile.getText().equals("")){
				LinkNewFileDialog.this.data.addFile(opName, fileType, addFile.getText(), "");
			}
			
			LinkNewFileDialog.this.data.frame.updateViews();
			LinkNewFileDialog.this.dispose();
		}
		
	};
	
	ActionListener cancel = new ActionListener(){

		public void actionPerformed(ActionEvent arg0) {
			LinkNewFileDialog.this.dispose();
		}
		
	};
	
	void createFilePane(){
		filePane.setLayout(new GridBagLayout());
		GridBagConstraints c = new GridBagConstraints();
		c.fill = GridBagConstraints.BOTH;
		c.weightx = 1;
		filePane.add(addFile, c);
		c.weightx = 0;
		c.gridx = 1;
		filePane.add(new GeneralUtil.pickAFileButton(addFile, data.frame));
	}
	
	void createInOutPane(){
		ButtonGroup pickOne = new ButtonGroup();
		pickOne.add(infile);
		pickOne.add(outfile);
		
		inOutPane.setLayout(new GridBagLayout());
		GridBagConstraints c = new GridBagConstraints();
		c.fill = GridBagConstraints.BOTH;
		c.weightx = 1;
		c.gridwidth = 2;
		inOutPane.add(new JLabel("Link to: " + opName), c);
		c.weightx = 0.5;
		c.gridwidth = 1;
		c.gridy = 1;
		inOutPane.add(infile, c);
		c.gridx = 1;
		inOutPane.add(outfile, c);
	}
	
	void createButtonPane(){
		buttonPane.add(ok);
		buttonPane.add(quit);
	}

	
	public LinkNewFileDialog(MainFrame mf, String given_opName){
		super(mf, "Link New File to " + given_opName);
		
		data = mf.data;
		opName = given_opName;
		addFile = new JTextField(10);
		infile = new JRadioButton("Input file");
		infile.setSelected(true);
		outfile = new JRadioButton("Output file");
		ok = new JButton("Ok");
		ok.addActionListener(process);
		quit = new JButton("Cancel");
		quit.addActionListener(cancel);
		filePane = new JPanel();
		inOutPane = new JPanel();
		buttonPane = new JPanel();
		
		createFilePane();
		createInOutPane();
		createButtonPane();
		
		getContentPane().setLayout(new BoxLayout(this.getContentPane(), BoxLayout.PAGE_AXIS));
		getContentPane().add(filePane);
		getContentPane().add(inOutPane);
		getContentPane().add(buttonPane);
		
		pack();
		setVisible(true);
	}
	
}
